(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('@angular/core'), require('@ng-bootstrap/ng-bootstrap'), require('@angular/forms'), require('@angular/common'), require('rxjs'), require('moment')) :
    typeof define === 'function' && define.amd ? define('@joffarex/ng-bootstrap-datetime-angular', ['exports', '@angular/core', '@ng-bootstrap/ng-bootstrap', '@angular/forms', '@angular/common', 'rxjs', 'moment'], factory) :
    (global = typeof globalThis !== 'undefined' ? globalThis : global || self, factory((global.joffarex = global.joffarex || {}, global.joffarex['ng-bootstrap-datetime-angular'] = {}), global.ng.core, global.ngBootstrap, global.ng.forms, global.ng.common, global.rxjs, global.moment_));
}(this, (function (exports, i0, ngBootstrap, forms, common, rxjs, moment_) { 'use strict';

    function _interopNamespace(e) {
        if (e && e.__esModule) { return e; } else {
            var n = Object.create(null);
            if (e) {
                Object.keys(e).forEach(function (k) {
                    if (k !== 'default') {
                        var d = Object.getOwnPropertyDescriptor(e, k);
                        Object.defineProperty(n, k, d.get ? d : {
                            enumerable: true,
                            get: function () {
                                return e[k];
                            }
                        });
                    }
                });
            }
            n['default'] = e;
            return Object.freeze(n);
        }
    }

    var moment___namespace = /*#__PURE__*/_interopNamespace(moment_);

    var NgBootstrapDatetimeAngularService = /** @class */ (function () {
        function NgBootstrapDatetimeAngularService() {
        }
        return NgBootstrapDatetimeAngularService;
    }());
    NgBootstrapDatetimeAngularService.ɵprov = i0.ɵɵdefineInjectable({ factory: function NgBootstrapDatetimeAngularService_Factory() { return new NgBootstrapDatetimeAngularService(); }, token: NgBootstrapDatetimeAngularService, providedIn: "root" });
    NgBootstrapDatetimeAngularService.decorators = [
        { type: i0.Injectable, args: [{
                    providedIn: 'root'
                },] }
    ];
    NgBootstrapDatetimeAngularService.ctorParameters = function () { return []; };

    var moment = moment___namespace;
    var NgBootstrapDatetimeAngularComponent = /** @class */ (function () {
        function NgBootstrapDatetimeAngularComponent(config, inj) {
            this.config = config;
            this.inj = inj;
            this.inputDatetimeFormat = 'd/M/yyyy H:mm:ss';
            this.placeholder = "";
            this.hourStep = 1;
            this.minuteStep = 15;
            this.secondStep = 30;
            this.seconds = true;
            this.disabled = false;
            this.onTouched = rxjs.noop;
            this.onChange = rxjs.noop;
            config.autoClose = 'outside';
            config.placement = 'auto';
        }
        NgBootstrapDatetimeAngularComponent.prototype.ngOnInit = function () {
            // tslint:disable-next-line: deprecation
            this.ngControl = this.inj.get(forms.NgControl);
        };
        NgBootstrapDatetimeAngularComponent.prototype.ngAfterViewInit = function () {
        };
        NgBootstrapDatetimeAngularComponent.prototype.writeValue = function (newModel) {
            if (newModel) {
                var myDate = moment(newModel).toDate();
                this.dateStruct = {
                    year: myDate.getFullYear(),
                    month: myDate.getMonth() + 1,
                    day: myDate.getDate()
                };
                this.timeStruct = {
                    hour: myDate.getHours(),
                    minute: myDate.getMinutes(),
                    second: myDate.getSeconds()
                };
                this.setDateStringModel();
            }
        };
        NgBootstrapDatetimeAngularComponent.prototype.registerOnChange = function (fn) {
            this.onChange = fn;
        };
        NgBootstrapDatetimeAngularComponent.prototype.registerOnTouched = function (fn) {
            this.onTouched = fn;
        };
        NgBootstrapDatetimeAngularComponent.prototype.onInputChange = function ($event) { };
        NgBootstrapDatetimeAngularComponent.prototype.onDateChange = function (event) {
            this.setDateStringModel();
        };
        NgBootstrapDatetimeAngularComponent.prototype.onTimeChange = function (event) {
            this.setDateStringModel();
        };
        NgBootstrapDatetimeAngularComponent.prototype.setDateStringModel = function () {
            if (!this.timeStruct) {
                var dateA = new Date();
                this.timeStruct = {
                    hour: dateA.getHours(),
                    minute: dateA.getMinutes(),
                    second: dateA.getSeconds()
                };
            }
            if (this.dateStruct) {
                this.date = new Date(this.dateStruct.year, this.dateStruct.month - 1, this.dateStruct.day, this.timeStruct.hour, this.timeStruct.minute, this.timeStruct.second);
                this.onChange(this.date);
            }
        };
        NgBootstrapDatetimeAngularComponent.prototype.inputBlur = function ($event) {
            this.onTouched();
        };
        return NgBootstrapDatetimeAngularComponent;
    }());
    NgBootstrapDatetimeAngularComponent.decorators = [
        { type: i0.Component, args: [{
                    selector: 'ng-bootstrap-datetime-angular',
                    template: "<div class=\"input-group mr-2\">\r\n  <input\r\n    [placeholder]=\"placeholder\"\r\n    [ngClass]=\"ngControl?.valid ? 'ng-valid' : 'ng-invalid'\"\r\n    class=\"form-control\"\r\n    (blur)=\"inputBlur($event)\"\r\n    [ngModel]=\"date | date: inputDatetimeFormat\"\r\n    (change)=\"onInputChange($event)\"\r\n    [disabled]=\"disabled\"\r\n  />\r\n\r\n  <div class=\"input-group-append\">\r\n    <button\r\n      class=\"btn btn-outline-secondary\"\r\n      [ngbPopover]=\"calendarContent\"\r\n      [disabled]=\"disabled\"\r\n      type=\"button\"\r\n    >\r\n      <i class=\"fa fa-calendar\"></i>\r\n    </button>\r\n  </div>\r\n</div>\r\n\r\n<ng-template #calendarContent>\r\n  <div>\r\n    <div>\r\n      <ngb-datepicker\r\n        #dp\r\n        name=\"datepicker\"\r\n        [(ngModel)]=\"dateStruct\"\r\n        (ngModelChange)=\"onDateChange($event)\"\r\n      ></ngb-datepicker>\r\n      <ngb-timepicker\r\n        meridian=\"true\"\r\n        [seconds]=\"false\"\r\n        #tp\r\n        name=\"timepicker\"\r\n        [(ngModel)]=\"timeStruct\"\r\n        (ngModelChange)=\"onTimeChange($event)\"\r\n        [seconds]=\"seconds\"\r\n        [hourStep]=\"hourStep\"\r\n        [minuteStep]=\"minuteStep\"\r\n      ></ngb-timepicker>\r\n    </div>\r\n  </div>\r\n</ng-template>\r\n",
                    providers: [
                        common.DatePipe,
                        {
                            provide: forms.NG_VALUE_ACCESSOR,
                            useExisting: i0.forwardRef(function () { return NgBootstrapDatetimeAngularComponent; }),
                            multi: true
                        }
                    ]
                },] }
    ];
    NgBootstrapDatetimeAngularComponent.ctorParameters = function () { return [
        { type: ngBootstrap.NgbPopoverConfig },
        { type: i0.Injector }
    ]; };
    NgBootstrapDatetimeAngularComponent.propDecorators = {
        inputDatetimeFormat: [{ type: i0.Input }],
        placeholder: [{ type: i0.Input }],
        hourStep: [{ type: i0.Input }],
        minuteStep: [{ type: i0.Input }],
        secondStep: [{ type: i0.Input }],
        seconds: [{ type: i0.Input }],
        disabled: [{ type: i0.Input }],
        dp: [{ type: i0.ViewChild, args: [ngBootstrap.NgbDatepicker, { static: false },] }],
        popover: [{ type: i0.ViewChild, args: [ngBootstrap.NgbPopover, { static: false },] }]
    };

    var NgBootstrapDatetimeAngularModule = /** @class */ (function () {
        function NgBootstrapDatetimeAngularModule() {
        }
        return NgBootstrapDatetimeAngularModule;
    }());
    NgBootstrapDatetimeAngularModule.decorators = [
        { type: i0.NgModule, args: [{
                    declarations: [NgBootstrapDatetimeAngularComponent],
                    imports: [
                        forms.FormsModule,
                        ngBootstrap.NgbModule,
                        common.CommonModule,
                        forms.ReactiveFormsModule
                    ],
                    exports: [NgBootstrapDatetimeAngularComponent]
                },] }
    ];

    /*
     * Public API Surface of ng-bootstrap-datetime-angular
     */

    /**
     * Generated bundle index. Do not edit.
     */

    exports.NgBootstrapDatetimeAngularComponent = NgBootstrapDatetimeAngularComponent;
    exports.NgBootstrapDatetimeAngularModule = NgBootstrapDatetimeAngularModule;
    exports.NgBootstrapDatetimeAngularService = NgBootstrapDatetimeAngularService;

    Object.defineProperty(exports, '__esModule', { value: true });

})));
//# sourceMappingURL=joffarex-ng-bootstrap-datetime-angular.umd.js.map
