import { ɵɵdefineInjectable, Injectable, Component, forwardRef, Injector, Input, ViewChild, NgModule } from '@angular/core';
import { NgbPopoverConfig, NgbDatepicker, NgbPopover, NgbModule } from '@ng-bootstrap/ng-bootstrap';
import { NgControl, NG_VALUE_ACCESSOR, FormsModule, ReactiveFormsModule } from '@angular/forms';
import { DatePipe, CommonModule } from '@angular/common';
import { noop } from 'rxjs';
import * as moment_ from 'moment';

class NgBootstrapDatetimeAngularService {
    constructor() { }
}
NgBootstrapDatetimeAngularService.ɵprov = ɵɵdefineInjectable({ factory: function NgBootstrapDatetimeAngularService_Factory() { return new NgBootstrapDatetimeAngularService(); }, token: NgBootstrapDatetimeAngularService, providedIn: "root" });
NgBootstrapDatetimeAngularService.decorators = [
    { type: Injectable, args: [{
                providedIn: 'root'
            },] }
];
NgBootstrapDatetimeAngularService.ctorParameters = () => [];

const moment = moment_;
class NgBootstrapDatetimeAngularComponent {
    constructor(config, inj) {
        this.config = config;
        this.inj = inj;
        this.inputDatetimeFormat = 'd/M/yyyy H:mm:ss';
        this.placeholder = "";
        this.hourStep = 1;
        this.minuteStep = 15;
        this.secondStep = 30;
        this.seconds = true;
        this.disabled = false;
        this.onTouched = noop;
        this.onChange = noop;
        config.autoClose = 'outside';
        config.placement = 'auto';
    }
    ngOnInit() {
        // tslint:disable-next-line: deprecation
        this.ngControl = this.inj.get(NgControl);
    }
    ngAfterViewInit() {
    }
    writeValue(newModel) {
        if (newModel) {
            const myDate = moment(newModel).toDate();
            this.dateStruct = {
                year: myDate.getFullYear(),
                month: myDate.getMonth() + 1,
                day: myDate.getDate()
            };
            this.timeStruct = {
                hour: myDate.getHours(),
                minute: myDate.getMinutes(),
                second: myDate.getSeconds()
            };
            this.setDateStringModel();
        }
    }
    registerOnChange(fn) {
        this.onChange = fn;
    }
    registerOnTouched(fn) {
        this.onTouched = fn;
    }
    onInputChange($event) { }
    onDateChange(event) {
        this.setDateStringModel();
    }
    onTimeChange(event) {
        this.setDateStringModel();
    }
    setDateStringModel() {
        if (!this.timeStruct) {
            const dateA = new Date();
            this.timeStruct = {
                hour: dateA.getHours(),
                minute: dateA.getMinutes(),
                second: dateA.getSeconds()
            };
        }
        if (this.dateStruct) {
            this.date = new Date(this.dateStruct.year, this.dateStruct.month - 1, this.dateStruct.day, this.timeStruct.hour, this.timeStruct.minute, this.timeStruct.second);
            this.onChange(this.date);
        }
    }
    inputBlur($event) {
        this.onTouched();
    }
}
NgBootstrapDatetimeAngularComponent.decorators = [
    { type: Component, args: [{
                selector: 'ng-bootstrap-datetime-angular',
                template: "<div class=\"input-group mr-2\">\r\n  <input\r\n    [placeholder]=\"placeholder\"\r\n    [ngClass]=\"ngControl?.valid ? 'ng-valid' : 'ng-invalid'\"\r\n    class=\"form-control\"\r\n    (blur)=\"inputBlur($event)\"\r\n    [ngModel]=\"date | date: inputDatetimeFormat\"\r\n    (change)=\"onInputChange($event)\"\r\n    [disabled]=\"disabled\"\r\n  />\r\n\r\n  <div class=\"input-group-append\">\r\n    <button\r\n      class=\"btn btn-outline-secondary\"\r\n      [ngbPopover]=\"calendarContent\"\r\n      [disabled]=\"disabled\"\r\n      type=\"button\"\r\n    >\r\n      <i class=\"fa fa-calendar\"></i>\r\n    </button>\r\n  </div>\r\n</div>\r\n\r\n<ng-template #calendarContent>\r\n  <div>\r\n    <div>\r\n      <ngb-datepicker\r\n        #dp\r\n        name=\"datepicker\"\r\n        [(ngModel)]=\"dateStruct\"\r\n        (ngModelChange)=\"onDateChange($event)\"\r\n      ></ngb-datepicker>\r\n      <ngb-timepicker\r\n        meridian=\"true\"\r\n        [seconds]=\"false\"\r\n        #tp\r\n        name=\"timepicker\"\r\n        [(ngModel)]=\"timeStruct\"\r\n        (ngModelChange)=\"onTimeChange($event)\"\r\n        [seconds]=\"seconds\"\r\n        [hourStep]=\"hourStep\"\r\n        [minuteStep]=\"minuteStep\"\r\n      ></ngb-timepicker>\r\n    </div>\r\n  </div>\r\n</ng-template>\r\n",
                providers: [
                    DatePipe,
                    {
                        provide: NG_VALUE_ACCESSOR,
                        useExisting: forwardRef(() => NgBootstrapDatetimeAngularComponent),
                        multi: true
                    }
                ]
            },] }
];
NgBootstrapDatetimeAngularComponent.ctorParameters = () => [
    { type: NgbPopoverConfig },
    { type: Injector }
];
NgBootstrapDatetimeAngularComponent.propDecorators = {
    inputDatetimeFormat: [{ type: Input }],
    placeholder: [{ type: Input }],
    hourStep: [{ type: Input }],
    minuteStep: [{ type: Input }],
    secondStep: [{ type: Input }],
    seconds: [{ type: Input }],
    disabled: [{ type: Input }],
    dp: [{ type: ViewChild, args: [NgbDatepicker, { static: false },] }],
    popover: [{ type: ViewChild, args: [NgbPopover, { static: false },] }]
};

class NgBootstrapDatetimeAngularModule {
}
NgBootstrapDatetimeAngularModule.decorators = [
    { type: NgModule, args: [{
                declarations: [NgBootstrapDatetimeAngularComponent],
                imports: [
                    FormsModule,
                    NgbModule,
                    CommonModule,
                    ReactiveFormsModule
                ],
                exports: [NgBootstrapDatetimeAngularComponent]
            },] }
];

/*
 * Public API Surface of ng-bootstrap-datetime-angular
 */

/**
 * Generated bundle index. Do not edit.
 */

export { NgBootstrapDatetimeAngularComponent, NgBootstrapDatetimeAngularModule, NgBootstrapDatetimeAngularService };
//# sourceMappingURL=joffarex-ng-bootstrap-datetime-angular.js.map
